LIBRARY IEEE ;
USE IEEE.STD_LOGIC_1164.ALL ;

ENTITY StateMachine IS
	GENERIC (
		....
		....
		....
		....
	)
	PORT (	
		....
		....
		....
		....
		Rstb : IN Std_Logic;
		Clk : IN Std_Logic );
END StateMachine ;


ARCHITECTURE comportementale OF StateMachine IS

	TYPE StateType IS (
		E0, E1, E2, E3, ....... , EN);

	SIGNAL EtatCourant, EtatSuivant : StateType;

BEGIN
	synchrone : PROCESS(Clk, Rstb)
	BEGIN
		IF Rstb = '0' THEN
			EtatCourant <= E0;
		ELSIF Clk'event AND Clk = '0' THEN
			EtatCourant <= EtatSuivant;
		END IF;
	END PROCESS synchrone ;

	LC1 : PROCESS(EtatCourant)

	BEGIN
		CASE EtatCourant IS

			WHEN E0 =>
				IF (transition valide) THEN
					EtatSuivant <= E1 ;
				ELSE 
					EtatSuivant <= E0 ;
				END IF;
			WHEN E1 =>
				IF (transition valide) THEN
					EtatSuivant <= E2 ;
				ELSE 
					EtatSuivant <= E1 ;
				END IF;
			WHEN E2 =>
				IF (transition valide) THEN
					EtatSuivant <= E3 ;
				ELSE 
					EtatSuivant <= E2 ;
				END IF;
			....
			....
			....
			....
			....
			....

			WHEN OTHERS => 
				EtatSuivant <= E0 ;

		END CASE;

	END PROCESS LC1 ;


	LC2 : PROCESS(EtatCourant)

	BEGIN
		CASE EtatCourant IS

			WHEN E0 =>
				SignalSortie1 <= '1' ;
				SignalSortie2 <= '0' ;
				....
				....
				SignalSortie2 <= '1' ;

			WHEN E1 =>
				SignalSortie1 <= '1' ;
				SignalSortie2 <= '0' ;
				....
				....
				SignalSortie2 <= '1' ;

			WHEN E2 =>
				SignalSortie1 <= '1' ;
				SignalSortie2 <= '0' ;
				....
				....
				SignalSortie2 <= '1' ;

			....
			....
			....
			....
			....
			....

			WHEN OTHERS =>
				SignalSortie1 <= '0' ;
				SignalSortie2 <= '0' ;
				....
				....
				SignalSortie2 <= '0' ;

		END CASE;

	END PROCESS LC2 ;

END comportementale;

